

local myname = "BossBlock"

BossBlock = AceAddon:new({
	name          = "BossBlock",
	description   = GetAddOnMetadata(myname, "Notes"),
	version       = string.sub(GetAddOnMetadata(myname, "X-Build"), 12, -3),
	releaseDate   = string.sub(GetAddOnMetadata(myname, "X-ReleaseDate"), 8, 18),
	author        = GetAddOnMetadata(myname, "Author"),
	email   	    = GetAddOnMetadata(myname, "X-Email"),
	website       = GetAddOnMetadata(myname, "X-Website"),
	category      = GetAddOnMetadata(myname, "X-Category"),

	aceCompatible = 103,
	cmd           = AceChatCmd:new({"/bossblock"},{}),

--	showtells = true,
--	showraid = true,
--	showraidsay = true,
--	showraidwarn = true,

	raidchans = {
		CHAT_MSG_RAID = true,
		CHAT_MSG_RAID_WARNING = true,
		CHAT_MSG_RAID_LEADER = true,
	},
	blockstrings = {
		["YOU HAVE THE PLAGUE!"] = true,
		["YOU ARE THE BOMB!"] = true,
		["YOU ARE BEING WATCHED!"] = true,
		["YOU ARE CURSED!"] = true,
		["YOU ARE BURNING!"] = true,
		["YOU ARE AFFLICTED BY VOLATILE INFECTION!"] = true,
		["YOU ARE MARKED!"] = true,
	},
	blockregexs = {
		"^%*+ .+ %*+$",
	},
})


function BossBlock:Enable()
	self:Hook("ChatFrame_OnEvent")
	self:Hook("RaidWarningFrame_OnEvent")
	if CT_RAMessageFrame then self:Hook(CT_RAMessageFrame, "AddMessage", "CTRA_AddMessage") end
end


function BossBlock:ChatFrame_OnEvent(event)
	if event == "CHAT_MSG_WHISPER" and not self.showtells and self:IsSpam(arg1) then return end
	if self.raidchans[event] and not self.showraid and self:IsSpam(arg1) then return end
	self:CallHook("ChatFrame_OnEvent", event)
end


function BossBlock:RaidWarningFrame_OnEvent(event, message)
	if not self.showraidwarn and self:IsSpam(message) then return end
	self:CallHook("RaidWarningFrame_OnEvent", event, message)
end


function BossBlock:CTRA_AddMessage(text, red, green, blue, alpha, holdTime)
	if not self.showraidsay and self:IsSpam(text) then return end
	self:CallHook(CT_RAMessageFrame, "AddMessage", text, red, green, blue, alpha, holdTime)
end


function BossBlock:IsSpam(text)
	if not text then return end
	if self.blockstrings[text] then return true end
	for _,regex in pairs(self.blockregexs) do if string.find(text, regex) then return true end end
end


BossBlock:RegisterForLoad()
